<?php
/**
 *
 * This software is distributed under the GNU LGPL v3.0 license.
 * Pirate's project
 * PostEngine
 * @author Vladyslav Karpenko <Pirate>
 * @copyright 2008-2010
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt
 * @link http://postengine.ru
 * @version 1.0
 */
$t = microtime(true); // засекаем скорость
$style = 'default'; // применяем стиль
$user = 0; // отключаем пользователя
$set = 0; // отключаем настройки
for($i=0; $i<60; $i++)
{
	$p=str_repeat('../', $i);
 	if(file_exists($p.'base.level'))
 	{
  		define('BASE', $p);
  		break;
 	}
	if($i==59) die('PostEngine not found!');
}
unset($i, $p);
error_reporting(-1) ; // отключаем показ ошибок
ini_set('display_errors', 1);
$act = isset($_GET['act']) ? $_GET['act'] : null; // работа со switch
require_once '../system/functions.php'; // стартуем функции
// Функция проверки прав доступа к файлам и папкам
function permissions($file)
{
	return @ decoct(@ fileperms($file)) % 1000;
}
$cherr = 0;
head('Установка PostEngine');
switch($act)
{
	default:
 	///////////////////////////////////////////////////////
  	//Приветствие										 //
   	///////////////////////////////////////////////////////
    echo '<div class="htitle">Добро пожаловать в мастер установки PostEngine</div>
    <div class="box_1">
  	<li>Дополнительную информацию Вы можете получить на официальном сайте проекта <a href="http://postengine.ru">postengine.ru</a>.</li>
   	<li>Установка и использование скриптов PostEngine, означает полное согласие с условиями <a href="http://www.gnu.org/licenses/lgpl-3.0.txt">лицензии</a>.</li>
    <h2>Дорогой WAP-мастер!</h2>
    У вас в руках первая версия форумного движка PostEngine!<br />
   	Один раз в месяц будет выходить новая версия ветки (1.1,1.2 и т.д.)
   	и несколько раз в неделю будут выходить новые версии последней части ветки!<br />
   	Скрипт рекомендуется к скачиванию <span style="text-decoration:underline"><strong>ТОЛЬКО</strong></span> на официальном форуме поддержки!<br />
   	Спасибо за внимание, а теперь предлагаю <a href="index.php?act=check">начать установку!</a></div>';
	break;
	case 'check':
 	///////////////////////////////////////////////////////
  	//Проверка											 //
   	///////////////////////////////////////////////////////
 	echo '<div class="htitle">Проверка системы</div>';
  	// Проверка прав доступа к папкам
  	if(chmod(BASE.'files/', 0777))
  	{
   		echo '<div class="message">На папку "files" успешно установлены CHMOD 777!</div>';
   	}
    else
    {
   		echo '<div class="error">Автоматическая установка CHMOD на папку "files" потерпела неудачи!<br />
        На данный момент: '.permissions(BASE.'files/').'
        Нужно установить:  0777</div>';
    }
    if(chmod(BASE.'admin/dumps/', 0777))
    {
        echo '<div class="message">На папку "dumps" успешно установлены CHMOD 777!</div>';
    }
    else
    {
        echo '<div class="error">Автоматическая установка CHMOD на папку "admin/dumps/" потерпела неудачи!<br />
        На данный момент: '.permissions(BASE.'admin/dumps/').'
        Нужно установить: 0777</div>';
    }
    echo '<div class="box_1"><a href="index.php?act=tables">Продолжить установку</a></div>';
	break;
	case 'tables':
	///////////////////////////////////////////////////////
  	//Установка											 //
   	///////////////////////////////////////////////////////
	echo '<div class="htitle">Установка системы</div>';
	if(isset($_POST['host']) and !empty($_POST['host']) and !empty($_POST['user']) and !empty($_POST['name']) and !empty($_POST['login']) and !empty($_POST['password']))
	{
 		$dbhost = htmlspecialchars(trim($_POST['host']));
 		$dbuser = htmlspecialchars(trim($_POST['user']));
 		$dbpass = htmlspecialchars(trim($_POST['pass']));
 		$dbname = htmlspecialchars(trim($_POST['name']));
 		$login = mysql_escape_string($_POST['login']);
 		$password = mysql_escape_string($_POST['password']);
 		$sql=new mysqli($dbhost, $dbuser, $dbpass, $dbname);
		if(mysqli_connect_errno($sql))
 		{
 			echo '<div class="error">Соединение отсутствует!</div>';
  			foot($t);
  			exit;
  		}

 		$sql->query('SET NAMES `utf8`');

	 	$create = file_get_contents('tables.sql');
 		$base = split(";(\r|\n)", $create);
 		foreach ($base as $qu)
 		{
  			if (NULL != $qu) $sql->query($qu);
 		}
 		$sql->query("insert into `users`(login,password,level,style) values('".$login."','".md5_sault($password)."',3,'default')");
 		$dir = scandir(BASE.'smiles');
 		natsort($dir);
 		foreach($dir as $v)
 		{
  			$c = str_replace('.gif', '', $v);
    		if(is_dir(BASE.'smiles/'.$v)) continue;
  			if($v=='.htaccess') continue;
  			$sql->query("insert into `smiles`(code,smile_url) values(':$c','$v')");
 		}
 		$file=file(BASE.'system/core.php');
 		$file[17]="define ('DBHOST', '$dbhost');\n";
 		$file[18]="define ('DBNAME', '$dbname');\n";
 		$file[19]="define ('DBUSER', '$dbuser');\n";
 		$file[20]="define ('DBPASS', '$dbpass');\n";
 		file_put_contents(BASE.'system/core.php', $file);
 		unlink('tables.sql');
		echo '<div class="message">PostEngine успешно установлен!</div><div class="box_1"><a href="index.php?act=final">Закончить установку</a></div>';
		foot($t);
		exit;
	}
	echo '<div class="box_1">
	<form action="index.php?act=tables" method="post">
	<div>
	Введите сервер базы данных:<br />
	<input name="host" type="text" value="localhost" /><br />
	Введите пользователя базы данных:<br />
	<input name="user" type="text" value="root" /><br />
	Введите пароль пользователя базы данных:<br />
	<input name="pass" type="text" /><br />
	Введите имя базы данных:<br />
	<input name="name" type="text" value="postengine" /><br />
	Введите логин ажминистратора:<br />
	<input name="login" type="text" value="Admin" /><br />
	Введите пароль администратора:<br />
	<input name="password" type="text" /><br />
	<input type="submit" value="Установить!" />
	</div>
	</form>
	</div>';
	break;
	case 'final':
 	///////////////////////////////////////////////////////
  	//Финализация										 //
   	///////////////////////////////////////////////////////
    echo '<div class="box_2">
    <h2>Спасибо за установку PostEngine!</h2>
    Я искренне желаю процветания вашего форума на просторах рувапа.<br />
    Поддержка по форуму предоставляется только на официальном форуме <a href="http://postengine.ru">postengine.ru</a>!<br />
    До свиданья в пакете обновления!<br />
    <strong><span style="color:#ff0000">НЕ ЗАБУДЬТЕ УДАЛИТЬ ПАПКУ install</span>!!!</strong><br />
    <a href="'.BASE.'index.php">Перейти на форум</a> или перейти в <a href="'.BASE.'admin/index.php">Перейти в панель управления</a>.
    </div>';
   	break;
}
foot($t);
?>