<?php
/**
 * Pirate's sproject
 * PHPMe Forum v.1.0
 *
 * @package
 * @author Vladyslav Karpenko <Pirate>
 * @copyright Copyright (c) 2008-2010
 * @license http://forum.phpme.ru/license.txt
 * @link http://forum.phpme.ru
 */
session_start();
require_once 'system/core.php';
require_once 'system/functions.php';
unreg();
head('Регистрация');
if (isset($_POST['login']) and !empty($_POST['login']) and !empty($_POST['password']) and !empty($_POST['password1']) and !empty($_POST['code']))
{
	# Фильтруем все POST данные
	$login = protect($_POST['login']);
	$name = protect($_POST['name']);
	$mail = protect($_POST['mail']);
	$password = protect($_POST['password']);
	$password1 = protect($_POST['password1']);
	/**
	* $code не фильтруем потому что, если прописать в форме ввода каптчи 0000, функции возвращающие integer значения возвратят 0,
	после очистки кода сессии там уже будет 0, соответственно 0=0 каптча пройдена и здраствуй автореггер, в противном случае,
	0000 неравно 0, и автореггер работать не будет
	*/
 	$code = $_POST['code'];
	$pol = int($_POST['pol']);
	/* Проверка паролей */
	if($password != $password1)
	{
		echo '<div class="error">Пароли не совпадают!</div>
		<div class="box_2"><a href="signup.php">Назад</a></div>';
		foot($t);
		exit;
	}
	/* Проверка проверочного кода */
	if($_SESSION['code'] != $code)
	{
		echo '<div class="error">Проверочный код введен не верно!</div>
		<div class="box_2"><a href="signup.php">Назад</a></div>';
		foot($t);
		exit;
	}
	/* Проверка логина (зарегистрирован или нет) */
	if (mysql_result(mysql_query("SELECT COUNT(*) FROM `users` WHERE `login` = '".$login."' LIMIT 1"),0) != 0)
	{
		echo '<div class="error">Логин уже зарегистрирован!</div>
		<div class="box_2"><a href="signup.php">Назад</a></div>';
		foot($t);
		exit;
	}
	/* Проверка логина на символы */
 	if (!preg_match('|^[a-zа-я0-9\-]+$|i',$login))
 	{
		echo '<div class="error">В логине можно использовать только латиницу и цифры!</div>
		<div class="box_2"><a href="signup.php">Назад</a></div>';
		foot($t);
		exit;
    }
    /* Проверка email на символы */
    if (!empty($mail) and !preg_match('#^([a-z0-9_\-\.])+\@([a-z0-9_\-\.])+(\.([a-z0-9])+)+$#',$mail))
    {
		echo '<div class="error">Вы ввели неверный адрес e-mail, необходим формат name@site.domen!</div>
		<div class="box_2"><a href="signup.php">Назад</a></div>';
		foot($t);
		exit;
    }

	/* Проверка EMAIL на существование */
	if (!empty($mail) and (mysql_result(mysql_query("SELECT COUNT(*) FROM `users` WHERE `mail` = '".$mail."' LIMIT 1"),0) != 0))
	{
		echo '<div class="error">Пользователь с таким email уже зарегистрирован!</div>
		<div class="box_2"><a href="signup.php">Назад</a></div>';
		foot($t);
		exit;
	}
	else
	{
		$subject = "Регистрация ($set[site])";
		$regmail = "Здравствуйте ".$login."<br />\r\nТеперь вы зарегистрированный пользователь сайта $set[site] , сохраните ваш логин и пароль  в надежном месте, он вам еще пригодится.<br />\r\nВаши данные для входа на на сайт<br />\r\nЛогин: ".$login."<br />\r\nПароль: ".$password."<br />\r\n<br />\r\nНадеемся вам понравится на нашем форуме!<br />\r\nС уважением, администрация сайта<br />\r\n";
		$adds = "From: <$set[reg_mail]>\n";
		$adds .= "X-sender: <$set[reg_mail]>\n";
		$adds .= "Content-Type: text/html; charset=utf-8\n";
		mail($mail,$subject,$regmail,$adds);
 	}
	unset($_SESSION['code']);
	mysql_query("INSERT INTO `users` (login,password,name,mail,reg_time,gender,style,time) values('".$login."','".md5_sault($password)."','".$name."','".$mail."',".time().",".$pol.",'".$style."',".time().")");
	echo '<div class="message">Вы успешно зарегистрированы на форуме '.$set['site'].'!</div>
	<div class="box_2"><a href="sign.php?login='.$login.'&amp;password='.$password.'">Войти!</a></div>';
	foot($t);
	exit;
}
?>
<div class="box_2">
<form action="signup.php" method="post">
<div>
*Логин:<br/>
<input name="login" type="text" value="" /><br/>
*Имя:<br/>
<input name="name" type="text" value="" /><br/>
*Вы:<br/>
<select size="1" name="pol">
<option value="1">Парень</option>
<option value="2">Девушка</option>
</select><br/>
*Пароль:<br/>
<input name="password" type="text" value="" /><br/>
*Повторите пароль:<br/>
<input name="password1" type="text" value="" /><br/>
Почта (желательно, но не обезательно):<br/>
<input name="mail" type="text" value="" /><br/>
*Код с картинки: <img src="captcha.php" alt="captcha" /><br/>
<input name="code" type="text" value="" /><br/>
<input type="submit" value="Регистрировать!" /></div></form></div>
<?php
foot($t);
?>