<?php
/**
 *
 * This software is distributed under the GNU LGPL v3.0 license.
 * Pirate's project
 * PostEngine
 * @author Vladyslav Karpenko <Pirate>
 * @copyright 2008-2010
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt
 * @link http://postengine.ru
 * @version 1.0
 */
require_once '../system/core.php'; // стартуем ядро двигателя
require_once '../system/functions.php'; // стартуем функции
only_level(3);
head('Статистика системы');
function dirsize($dir)
{
	$totalsize=0;
	if ($dirstream = @opendir($dir))
	{
		while (false !== ($filename = readdir($dirstream)))
		{
			if ($filename!="." && $filename!="..")
			{
				if (is_file($dir."/".$filename))
				$totalsize+=filesize($dir."/".$filename);

				if (is_dir($dir."/".$filename))
				$totalsize+=dirsize($dir."/".$filename);
			}
		}
		closedir($dirstream);
		return $totalsize;
	}
}
$result = mysql_query( "SHOW TABLE STATUS" );
$dbsize = 0;
while( $row = mysql_fetch_array( $result ) ) {
$dbsize += $row[ "Data_length" ] + $row[ "Index_length" ];
}
/* Результаты в БД */
$smiles = mysql_result(mysql_query("select count(*) from `smiles`"),0);
$users = mysql_result(mysql_query("select count(*) from `users`"),0);
list ($php_ver1,$php_ver2,$php_ver3)=explode('.', strtok(strtok(phpversion(),'-'),' '), 3);

if ($php_ver1==5)
{
echo "<div class=\"box_1\">Версия PHP: $php_ver1.$php_ver2.$php_ver3 (OK)</div>\n";
}
else
{
echo "<div class=\"box_1\">Версия PHP: $php_ver1.$php_ver2.$php_ver3</div>\n";
echo "Тестирование на версии php $php_ver1.$php_ver2.$php_ver3 не осуществялось";
}




if (function_exists('disk_free_space') && function_exists('disk_total_space'))
{
$free_space=disk_free_space('../');
$total_space=disk_total_space('../');
if ($free_space>1024*1024*5)
echo "<div class=\"box_1\">Свободно: ".size($free_space).' / '.size($total_space)."</div>\n";
else
{
echo "<div class=\"box_1\">Свободно: ".size($free_space).' / '.size($total_space)."</div>\n";
echo 'Мало свободного места на диске';
}
}


if (function_exists('set_time_limit'))echo "<div class=\"box_1\">set_time_limit: OK</div>\n";
else echo "<div class=\"box_1\">set_time_limit: Запрещено</div>\n";


if (ini_get('magic_quotes_gpc')==0)
{
echo "<div class=\"box_1\">magic_quotes_gpc: 0 (OK)</div>\n";
}
else
{
echo "<div class=\"box_1\">magic_quotes_gpc: Включено</div>\n";
echo 'Включено экранирование кавычек';
echo 'Добавьте в корневой .htaccess строку <b>php_value magic_quotes_gpc 0</b>';
}

if (ini_get('arg_separator.output')=='&amp;')
{
echo "<div class=\"box_1\">arg_separator.output: &amp;amp; (OK)</div>\n";
}
else
{
echo "<div class=\"box_1\">arg_separator.output: ".ini_get('arg_separator.output')."</div>\n";
echo 'Возможно появление ошибки xml';
echo 'Добавьте в корневой .htaccess строку <b>php_value arg_separator.output &amp;amp;</b>';
}


if (function_exists('imagecreatefromstring') && function_exists('gd_info'))
{
$gdinfo=gd_info();
echo "<div class=\"box_1\">GD: ".$gdinfo['GD Version']." OK</div>\n";
}
else
{
echo "<div class=\"box_1\">GD: Нет</div>\n";
echo 'GD необходима для корректной работы движка';
}


if (function_exists('mysql_info'))
{
echo "<div class=\"box_1\">MySQL: OK</div>\n";
}
else
{
echo "<div class=\"box_1\">MySQL: Нет</div>\n";
echo 'Без MySQL работа не возможна';
}


if (function_exists('iconv'))
{
echo "<div class=\"box_1\">Iconv: OK</div>\n";
}
else
{
echo "<div class=\"box_1\">Iconv: Нет</div>\n";
echo 'Без Iconv работа не возможна';
}

if (class_exists('ffmpeg_movie'))
{
echo "<div class=\"box_1\">FFmpeg: OK</div>\n";
}
else
{
echo "<div class=\"box_1\">FFmpeg: Нет<br />\n";
echo "* Без FFmpeg автоматическое создание скриношотов к видео недоступно</div>\n";
}

if (ini_get('register_globals')==false)
{
echo "<div class=\"box_1\">register_globals off: OK</div>\n";
}
else
{
echo '<div class="box_1">register_globals on: !!!<br />
register_globals включен. Грубое нарушение безопасности!</div>';
}

if (function_exists('mcrypt_cbc'))
{
echo "<div class=\"box_1\">Шифрование COOKIE: OK</div>\n";
}
else
{
echo "<div class=\"box_1\">Шифрование COOKIE: нет<br />\n";
echo "* mcrypt не доступен</div>\n";
}
echo '<div class="box_1">
Пользователей: '.$users.'<br />
Размер базы данных: '.size($dbsize).'<br />
Размер папки файлов: '.size(dirsize(BASE.'files')).'<br />
Размер папки файлов дампов БД: '.size(dirsize('dumps')).'<br />
Размер папки файлов смайлов: '.size(dirsize(BASE.'/smiles')).'<br />
Размер системы: '.size(dirsize(BASE)).'<br />
Общий вес системы: '.size(dirsize(BASE)+$dbsize).'<br />
</div>';
foot($t);
?>