<?php
/**
 *
 * This software is distributed under the GNU LGPL v3.0 license.
 * Pirate's project
 * PostEngine
 * @author Vladyslav Karpenko <Pirate>
 * @copyright 2008-2010
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt
 * @link http://postengine.ru
 * @version 1.0
 */
require_once 'system/core.php'; // стартуем ядро двигателя
require_once 'system/functions.php'; // стартуем функции
head('Правила');
switch($act)
{
	case '1':
	echo '
	<div class="box_1">
		<b>1. <u>1.1</u></b> <br/>
		За порядком на форуме следят Администрация и специально назначенные модераторы. В их компетенцию входит изменение, удаление любых сообщений и тем в соответствующих разделах, закрытие доступа (временное или бессрочное) к Форуму пользователям, пренебрегающим настоящими Правилами.<br/>
	</div>
	<div class="box_2">
		<b>2. <u>1.2</u></b> <br/>
		Незнание данных Правил не только не освобождает от ответственности, но и само по себе является нарушением.<br/>
	</div>
	<div class="box_1">
		<b>3. <u>1.3</u></b> <br/>
		Интернациональным языком общения на Форуме является русский. Иные языки не приветствуются; их использование допустимо лишь в случаях, обусловленных необходимостью.<br/>
	</div>
	<div class="box_2">
		<b>4. <u>1.4</u></b> <br/>
		Регистрируясь, Вы автоматически соглашаетесь с настоящими правилами и обязуетесь соблюдать все их положения.<br/>
	</div>
	<div class="box_1">
		<b>5. <u>1.5</u></b> <br/>
		В ситуациях, не оговоренных Правилами, Администрация принимает решение, руководствуясь собственными ценностными установками.<br/>
	</div>
	<div class="box_2">
		<b>6. <u>1.6</u></b> <br/>
		Администрация не несёт ответственности за информацию, размещаемую пользователями.<br/>
	</div>
	<div class="box_1">
		<b>7. <u>1.7</u></b> <br/>
	Администрация сохраняет за собой право вносить изменения в настоящие Правила без предварительного уведомления пользователей.<br/>
	</div>';
break;
	case '2':
	echo '
	<div class="box_1">
		<b>1. <u>2.1</u></b> <br/>
		Если пользователь пренебрегает настоящими правилами, его учётная запись блокируется на срок, определяемый Администрацией.<br/>
	</div>
	<div class="box_2">
		<b>2. <u>2.2</u></b> <br/>
		Меру наказания Администрация определяет самостоятельно и вправе не объяснять причины.<br/>
	</div>
	<div class="box_1">
		<b>3. <u>2.3. Обход бана</u></b> <br/>
		В случае временного бана, сообщения с дополнительных учётных записей увеличивают срок наказания основной; прочие ники при этом удаляются.<br/>
	</div>
	<div class="box_2">
		<b>4. <u>2.4</u></b> <br/>
		Если участник систематически игнорирует требования Администрации, его учётная запись удаляется.<br/>
	</div>';
	break;
	case '3':
	echo '
	<div class="box_1">
		<b>1. <u>3.1</u></b> <br/>
		Допускается регистрация не более двух учётных записей на человека. При выявлении избытка удаляются все аккаунты пользователя.<br/>
	</div>
	<div class="box_2">
		<b>2. <u>3.2. Сходство с никами Администрации</u></b> <br/>
		Запрещается регистрация ников, имеющих сходство с никами представителей Администрации.<br/>
	</div>
	<div class="box_1">
		<b>3. <u>3.3</u></b> <br/>
		Запрещается использование ников, содержащих названия сайтов, нецензурные выражения или оскорбления.<br/>
	</div>
	<div class="box_2">
		<b>4. <u>3.4. Использование спецсимволов в нике</u></b> <br/>
	Запрещено регистрировать ники, состоящие из одних спецсимволов<br/>
	</div>
	<div class="box_1">
		<b>5. <u>3.5. Смена ника</u></b> <br/>
		Запрещена смена ника<br/>
	</div>';
	break;
	case '4':
	echo '
	<div class="box_1">
		<b>1. <u>4.1 Дубликаты тем</u></b> <br/>
		Запрещается создавать дубликаты тем. Если тема с таким названием или содержанием уже была в форуме (особенно недавно), пишите в ней свои вопросы и ответы.<br/>
	</div>
	<div class="box_2">
		<b>2. <u>4.2. Флуд тем</u></b> <br/>
		Запрещается создание тем в нескольких форумах одновременно.<br/>
	</div>
	<div class="box_1">
		<b>3. <u>4.3</u></b> <br/>
		Запрещается продолжение обсуждения вопросов и тем, закрытых или удалённых Администрацией.<br/>
	</div>
	<div class="box_2">
		<b>4. <u>4.4. Неинформатиное название темы</u></b> <br/>
		Название темы должно отражать её содержимое. Запрещается создание тем, имеющих малосодержательное название (например, &quot;Нужна помощь!&quot; или &quot;Есть вопрос!&quot;).<br/>
	</div>
	<div class="box_1">
		<b>5. <u>4.5</u></b> <br/>
		Запрещается создание тем, обращенных к конкретным участникам.<br/>
	</div>
	<div class="box_2">
		<b>6. <u>4.6. Украшение названия темы</u></b> <br/>
		Запрещается создание тем, имеющих в названии украшения вроде &quot;&lt;== Самая актуальная тема ==&gt;&quot;<br/>
	</div>';
	break;
	case '5':
	echo '
	<div class="box_1">
		<b>1. <u>5.1 Флуд</u></b> <br/>
		Запрещается размещать бессмысленную или малосодержательную информацию - пустую болтовню, не несущую смысловой нагрузки (флуд).<br/>
	</div>
	<div class="box_2">
		<b>2. <u>5.2 Оффтоп</u></b> <br/>
		Запрещается уход от основного обсуждения в рамках отдельной темы (оффтоп).<br/>
	</div>
	<div class="box_1">
		<b>3. <u>5.3 Флейм</u></b> <br/>
		Запрещается размещение сообщений грубых по тону, содержащих &quot;наезды&quot; на личности (флейм).<br/>
	</div>
	<div class="box_2">
		<b>4. <u>5.4 Реклама</u></b> <br/>
		Запрещается размещение сообщений, несущих явно рекламное содержание, в том числе с просьбой &quot;Посетить/оценить Ваш сайт&quot;, для этого есть раздел &quot;Реклама/Оценка сайтов&quot;<br/>
	</div>
	<div class="box_1">
		<b>5. <u>5.5 Мат</u></b> <br/>
		Запрещается использование мата.<br/>
	</div>
	<div class="box_2">
		<b>6. <u>5.6 Ложная информация</u></b> <br/>
		Запрещается размещение сообщений, содержащих заведомо ложную информацию, клевету.<br/>
	</div>
	<div class="box_1">
		<b>7. <u>5.7 Безосновательные утверждения</u></b> <br/>
		Запрещается размещение сообщений, содержащих безосновательные утверждения, что &quot;это&quot; лучше, а &quot;это&quot; хуже.<br/>
	</div>
	<div class="box_2">
		<b>8. <u>5.8 Чрезмерное количество смайлов и регистр</u></b> <br/>
		Запрещается размещение сообщений, содержащих чрезмерное количество смайлов, а так же использование только верхнего регистра,  мешающих нормальному восприятию текста.<br/>
	</div>
	<div class="box_1">
		<b>9. <u>5.9 Грамматические ошибки и жарогонные слова</u></b> <br/>
		Запрещается размещение сообщений, содержащих чрезмерное количество грамматических ошибок и жаргонных слов.<br/>
	</div>
	<div class="box_2">
		<b>10. <u>5.10 Призывы к нарушению</u></b> <br/>
		Запрещается размещение сообщений, содержащих призывы к нарушению действующего законодательства Российской Федерации и Украины.<br/>
	</div>
	<div class="box_1">
		<b>11. <u>5.11 Пропаганда</u></b> <br/>
		Запрещено размещение сообщений, содержащие пропаганду насилия, фашизма, коммунизма, терроризма, расовой ненависти и/или провозглашающие одну особенную расу, национальность или пол как превосходящие над другими<br/>
	</div>
	<div class="box_2">
		<b>12. <u>5.12 Вредоносные программы</u></b> <br/>
		Непозволительно размещение программ, которые могут причинить вред ресурсам (шелл, спамеры, вирусы и т.д.)<br/>
	</div>
	<div class="box_1">
		<b>13. <u>5.13 Авторские скрипты</u></b> <br/>
		Запрещено выкладывать или продавать авторские скрипты без согласия автора<br/>
	</div>
	<div class="box_2">
		<b>14. <u>5.14 Обсуждение администрации</u></b> <br/>
		Запрещается размещение сообщений, содержащих обсуждение, оспаривание действий Администрации Форума.<br/>
	</div>
	<div class="box_1">
		<b>15. <u>5.15 Поднятие темы</u></b> <br/>
		Запрещено поднимать темы сообщениями, не несущей полезной информации (ап, ^, вверх и т.п.)<br/>
	</div>
	<div class="box_2">
		<b>16. <u>5.16 Просьбы в долг</u></b> <br/>
		Запрещено оставлять сообщения с просьбой дать денежные средства в долг (выдача кредитов не запрещена).<br/>
	</div>
	<div class="box_1">
		<b>17. <u>5.17 Услуги (взлом, спам и т.д)</u></b> <br/>
		Запрещено размещение сообщений о предоставлении услуг, которые могут причинить вред ресурсам (взлом, спам и т.д.)<br/>
	</div>
	<div class="box_2">
		<b>18. <u>5.18 Некропостинг</u></b> <br/>
		Запрещён некропостинг. Поднимать тему можно только в случае, если у вас есть вопрос, не рассмотренный в топике.<br/>
	</div>';
	break;
	case '6':
	echo '
	<div class="box_1">
		<b>1. <u>6.1</u></b> <br/>
		Уважительно относитесь к собеседникам, правильно (грамотно) и доходчиво излагайте свои мысли и факты.<br/>
	</div>
	<div class="box_2">
		<b>2. <u>6.2</u></b> <br/>
		Не обращайте внимания на маргиналов и прочих брутальных личностей, не дразните и не подзадоривайте их - отсутствие внимания сразу сводит дискуссию на нет. Не стоит отвечать им той же монетой, даже если Вы считаете, что Вас оскорбили. Остальное - забота Администрации.<br/>
	</div>
	<div class="box_1">
		<b>3. <u>6.3</u></b> <br/>
		Если Вы видите сообщение, нарушающее настоящие Правила, не стоит кричать об этом во всеуслышание. Сообщите о нём Администрации Форума, используя специальную систему жалоб или личные сообщения.<br/>
	</div>
	<div class="box_2">
		<b>4. <u>6.4</u></b> <br/>
		Перед тем, как задать вопрос, воспользуйтесь внутренней поисковой системой Форума: вероятно, он уже обсуждался ранее.<br/>
	</div>';
	break;
}
echo '<div class="admin_box_1">Категории правил</div>
<div class="box_1">- <a href="rules.php?act=1">Общие положения</a></div>
<div class="box_2">- <a href="rules.php?act=2">Наказания</a></div>
<div class="box_1">- <a href="rules.php?act=3">Регистрация на форуме</a></div>
<div class="box_2">- <a href="rules.php?act=4">Создание темы</a></div>
<div class="box_1">- <a href="rules.php?act=5">Создание сообщения</a></div>
<div class="box_2">- <a href="rules.php?act=6">Рекомендации</a></div>';
foot($t);
?>